'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _storybook = require('@devexperts/tools/lib/utils/storybook');

var _Demo = require('../demo/Demo');

var _Demo2 = _interopRequireDefault(_Demo);

var _Deferred = require('./Deferred');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DeferredPage = function (_PureComponent) {
    _inherits(DeferredPage, _PureComponent);

    function DeferredPage() {
        _classCallCheck(this, DeferredPage);

        var _this = _possibleConstructorReturn(this, (DeferredPage.__proto__ || Object.getPrototypeOf(DeferredPage)).apply(this, arguments));

        _this.state = {
            counter: 0
        };
        return _this;
    }

    _createClass(DeferredPage, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
            var _this2 = this;

            this.interval = window.setInterval(function () {
                _this2.setState({
                    counter: _this2.state.counter + 1
                });
            }, 3000);
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            clearInterval(this.interval);
        }
    }, {
        key: 'render',
        value: function render() {
            var _this3 = this;

            return React.createElement(_Demo2.default, null, React.createElement("div", null, "Additional content will render in 2 seconds..."), React.createElement(_Deferred.Deferred, { render: function render() {
                    return React.createElement("div", null, "I'm heavy timer: ", _this3.state.counter);
                }, delay: 2000 }));
        }
    }]);

    return DeferredPage;
}(_react.PureComponent);

(0, _storybook.storiesOf)('Deferred', module).add('default', function () {
    return React.createElement(DeferredPage, null);
});