'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.PasswordInput = exports.RawPasswordInput = exports.PASSWORD_INPUT = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _tslib = require('tslib');

var tslib_1 = _interopRequireWildcard(_tslib);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _pure = require('../../utils/pure');

var _ButtonIcon = require('../ButtonIcon/ButtonIcon');

var _Input = require('../input/Input');

var _withTheme = require('../../utils/withTheme');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PASSWORD_INPUT = exports.PASSWORD_INPUT = Symbol('PasswordInput');
var RawPasswordInput = function (_React$Component) {
    _inherits(RawPasswordInput, _React$Component);

    function RawPasswordInput() {
        _classCallCheck(this, RawPasswordInput);

        var _this = _possibleConstructorReturn(this, (RawPasswordInput.__proto__ || Object.getPrototypeOf(RawPasswordInput)).apply(this, arguments));

        _this.onClickRevealButton = function () {
            var onReveal = _this.props.onReveal;

            onReveal && onReveal(!_this.props.isRevealed);
        };
        return _this;
    }

    _createClass(RawPasswordInput, [{
        key: 'render',
        value: function render() {
            var _a = this.props,
                theme = _a.theme,
                _a$Button = _a.Button,
                Button = _a$Button === undefined ? _ButtonIcon.ButtonIcon : _a$Button,
                _a$Input = _a.Input,
                Input = _a$Input === undefined ? _Input.Input : _a$Input,
                IconShow = _a.IconShow,
                IconHide = _a.IconHide,
                isDisabled = _a.isDisabled,
                isRevealed = _a.isRevealed,
                onReveal = _a.onReveal,
                restInputProps = tslib_1.__rest(_a, ["theme", "Button", "Input", "IconShow", "IconHide", "isDisabled", "isRevealed", "onReveal"]);
            var Icon = isRevealed ? IconShow : IconHide;
            return _react2.default.createElement("div", { className: theme.container }, _react2.default.createElement(Input, Object.assign({}, restInputProps, { theme: theme.Input, isDisabled: isDisabled, type: isRevealed ? 'text' : 'password' })), _react2.default.createElement(Button, { icon: _react2.default.createElement(Icon, null), theme: theme.RevealButton, isDisabled: isDisabled, onClick: this.onClickRevealButton }));
        }
    }]);

    return RawPasswordInput;
}(_react2.default.Component);
exports.RawPasswordInput = RawPasswordInput = tslib_1.__decorate([_pure.PURE], RawPasswordInput);
exports.RawPasswordInput = RawPasswordInput;
var PasswordInput = exports.PasswordInput = (0, _withTheme.withTheme)(PASSWORD_INPUT)(RawPasswordInput);