'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.BoundsUpdateDetector = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _reactDom = require('react-dom');

var ReactDOM = _interopRequireWildcard(_reactDom);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var BoundsUpdateDetector = exports.BoundsUpdateDetector = function (_React$Component) {
    _inherits(BoundsUpdateDetector, _React$Component);

    function BoundsUpdateDetector() {
        _classCallCheck(this, BoundsUpdateDetector);

        return _possibleConstructorReturn(this, (BoundsUpdateDetector.__proto__ || Object.getPrototypeOf(BoundsUpdateDetector)).apply(this, arguments));
    }

    _createClass(BoundsUpdateDetector, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.size = this.getSize();
        }
    }, {
        key: 'getSize',
        value: function getSize() {
            var element = ReactDOM.findDOMNode(this);
            return {
                width: element.offsetWidth,
                height: element.offsetHeight
            };
        }
    }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate(prevProps, prevState) {
            var size = this.getSize();
            var _size = this.size,
                width = _size.width,
                height = _size.height;

            if (height !== size.height || width !== size.width) {
                this.size = size;
                this.props.onUpdate && this.props.onUpdate(size);
            }
        }
    }, {
        key: 'render',
        value: function render() {
            return this.props.children;
        }
    }]);

    return BoundsUpdateDetector;
}(React.Component);