'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _storybook = require('@devexperts/tools/lib/utils/storybook');

var _Demo = require('../demo/Demo');

var _Demo2 = _interopRequireDefault(_Demo);

var _Menu = require('./Menu');

var _MenuPage = require('./Menu.page.styl');

var _MenuPage2 = _interopRequireDefault(_MenuPage);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var theme = {
    container: _MenuPage2.default.list
};
var Item = function Item(props) {
    return _react2.default.createElement(_Menu.MenuItem, Object.assign({}, props, { theme: theme }));
};
var Group = function Group(props) {
    return _react2.default.createElement(_Menu.MenuItemGroup, Object.assign({}, props, { theme: theme }));
};
var onItemSelect = function onItemSelect(value) {
    console.log('selected', value);
};
(0, _storybook.storiesOf)('Menu', module).add('default', function () {
    return _react2.default.createElement(_Demo2.default, null, _react2.default.createElement(_Menu.Menu, { onItemSelect: onItemSelect, theme: theme }, _react2.default.createElement(Item, { value: "1.1" }, "1.1"), _react2.default.createElement(Item, { value: "1.2" }, "1.2"), _react2.default.createElement(Group, { header: "2" }, _react2.default.createElement(_Menu.Menu, null, _react2.default.createElement(Item, { value: "2.1" }, "2.1"), _react2.default.createElement(Item, { value: "2.2" }, "2.2"), _react2.default.createElement(Group, { header: "3" }, _react2.default.createElement(_Menu.Menu, null, _react2.default.createElement(Item, { value: "3.1" }, "3.1"), _react2.default.createElement(Item, { value: "3.2" }, "3.2"), _react2.default.createElement(Group, { header: "3.3" }, _react2.default.createElement(_Menu.Menu, null, _react2.default.createElement(Item, { value: "3.3.1" }, "3.3.1"), _react2.default.createElement(Item, { value: "3.3.2" }, "3.3.2"), _react2.default.createElement(Item, { value: "3.3.3" }, "3.3.3"))), _react2.default.createElement(Item, { value: "3.4" }, "3.4")))))));
});